import { PureComponent } from 'react';
import { connect } from 'react-redux';
import Table from '@material-ui/core/Table';
import TableBody from '@material-ui/core/TableBody';
import TableCell from '@material-ui/core/TableCell';
import TableHead from '@material-ui/core/TableHead';
import TableRow from '@material-ui/core/TableRow';

import { getTableData } from '../../redux/actions/table';
import { generateData } from './utils';

import CircularProgress from '@material-ui/core/CircularProgress';

import './styles.less';

class SimpleTable extends PureComponent {
  state = {
    data: generateData(),
    showSpinner: true,
  };

  fetchTimer;

  componentDidMount() {
    /** TODO: For getting data from api, uncomment this line **/
    // this.props.getDataAction();

    /** TODO: Bad practice, done only for generate data **/
    this.fetchTimer = setInterval(() => {
      console.log('4');

      this.setState({
        data: generateData(),
      });
    }, 2000);
  }

  render() {
    const { data } = this.state;
    console.log(data);
    return (
      <div
        className={'home'}
        style={{ height: 'calc(100% - 65px)' }}
      >
        <div className="top-block">
          <div className="description">
            {'This page simulates working with sockets.'}
            <br/>
              {'Since API is not used in this project, the data is generated by a simple function.'}
            <br/>
            {'This table shows the status of the gaming tables.'}
          </div>
        </div>
        <div
          className={'content home-table'}
          style={{ height: 'calc(100% - 110px)' }}
        >
          <Table
            bodyStyle={{ height: 'calc(100% - 115px)', maxHeight: 530, overflowY: 'overlay', padding: '0 2px' }}
            className={'table in-popup table-main-header'}
            fixedHeader
            headerStyle={{ fontSize: '16px', padding: '0 2px' }}
            selectable={false}
            wrapperStyle={{
              marginBottom: -2,
            }}
          >
            <TableHead
              adjustForCheckbox={false}
              className={'header'}
              displaySelectAll={false}
            >
              <TableRow>
                <TableCell className={'column'}>{'Id'}</TableCell>
                <TableCell className={'column'}>{'Tpe'}</TableCell>
                <TableCell className={'column'}>{'Name'}</TableCell>
                <TableCell className={'column'}>{'Warning'}</TableCell>
                <TableCell className={'column'}>{'Players'}</TableCell>
                <TableCell className={'column'}>{'Max Players'}</TableCell>
              </TableRow>
            </TableHead>
            <TableBody
              className={'body'}
              displayRowCheckbox={false}
            >
              {this.state.data.map((row, index) => (
                <TableRow key={index} className={`${row.warning && 'warning'}`}>
                  <TableCell className={'column'}>{row.id}</TableCell>
                  <TableCell className={'column'}>{row.type}</TableCell>
                  <TableCell className={'column'}>{row.name}</TableCell>
                  <TableCell className={'column'}>{row.warning ? 'Warning!' : 'Ok'}</TableCell>
                  <TableCell className={'column'}>{row.players}</TableCell>
                  <TableCell className={'column'}>{row.maxPlayers}</TableCell>
                </TableRow>
              ))}
              {
                (this.state.data.length <= 0) &&
                <TableRow
                  colSpan="5"
                >
                  <TableHeaderColumn
                    className={'column'}
                    style={{
                      textAlign: 'center',
                    }}
                  >
                    {
                      this.state.showSpinner
                        ? <CircularProgress style={{ padding: 40 }} />
                        : 'No clusters installed!'
                    }
                  </TableHeaderColumn>
                </TableRow>
              }
            </TableBody>
          </Table>
        </div>
      </div>
    );
  }
}

const mapStateToProps = (state) => {
  const { tableData } = state;

  return {
    data: tableData || [],
  };
};

const mapDispatchToProps = (dispatch) => ({
  getDataAction: () => dispatch(getTableData())
});

const TableComponents = connect(mapStateToProps, mapDispatchToProps)(SimpleTable);

export { TableComponents };

